#include <winsock2.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/timeb.h>

#define BUFSIZE 4096

struct _msgAck
{
	char filename[256];
	int  totalsize;
	int  offset;
};

struct _msgData
{
	char filename[256];
	int  totalsize;
	int  offset;
	char buf[BUFSIZE];
	int  datasize;
};

//  Լ    
void err_quit(char *msg)
{
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER|
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL, WSAGetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf, 0, NULL);
	MessageBox(NULL, (LPCTSTR)lpMsgBuf, msg, MB_ICONERROR);
	LocalFree(lpMsgBuf);
	exit(-1);
}

//  Լ  
void err_display(char *msg)
{
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER|
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL, WSAGetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf, 0, NULL);
	printf("[%s] %s", msg, (LPCTSTR)lpMsgBuf);
	LocalFree(lpMsgBuf);
}

int main(int argc, char* argv[])
{
	int retval;
	
	if(argc < 2)
	{
		fprintf(stderr, "Usage: %s <FileName>\n", argv[0]);
		return -1;
	}

	//  ʱȭ
	WSADATA wsa;
	if(WSAStartup(MAKEWORD(2,2), &wsa) != 0)
		return -1;

	// socket()
	SOCKET sock = socket(AF_INET, SOCK_DGRAM, 0);
	if(sock == INVALID_SOCKET) err_quit("socket()");	
	
	//  ּ ü ʱȭ
	SOCKADDR_IN serveraddr;
	ZeroMemory(&serveraddr, sizeof(serveraddr));
	serveraddr.sin_family = AF_INET;
	serveraddr.sin_port = htons(9000);
	serveraddr.sin_addr.s_addr = inet_addr("127.0.0.1");

	// connect()
	retval = connect(sock, (SOCKADDR *)&serveraddr, sizeof(serveraddr));
	if(retval == SOCKET_ERROR) err_quit("connect()");

	//  ŸӾƿ 
	int optval = 200; // 200ms
	retval = setsockopt(sock, SOL_SOCKET, SO_RCVTIMEO, 
		(char *)&optval, sizeof(optval));
	if(retval == SOCKET_ERROR) err_quit("setsockopt()");

	//////////////////////////////////   α  //////////////////////////////////
	//  
	FILE *fp = fopen(argv[1], "rb");
	if(fp == NULL)
	{
		perror("");
		return -1;
	}
	
	//  ũ 
	fseek(fp, 0, SEEK_END);
	int totalsize = ftell(fp);
	rewind(fp);

	int numread;
	int numtotal = 0;					//   ũ
	int currbytes;						//   ũ
	int transfer_rate_old = 0;			// ٷ Ŷ  
	int transfer_rate_new = 0;			// ̹ Ŷ 鼭 Ǵ 
	bool file_resend = false;
	_msgAck msgAck;
	
	//////////////////////////////////  ޽ ʱȭ//////////////////////////////////
	_msgData msgData;
	ZeroMemory(&msgData, sizeof(msgData));		// ü ʱȭ
	wsprintf(msgData.filename, "%s", argv[1]);		//  ̸ ְ
	msgData.totalsize = totalsize;							//  ũ ֱ
	msgData.offset = 0;											//  ° ϴ 0

	/////////////////////////////    ִ üũ/////////////////////////////
	retval = send(sock, (char *)&msgData, sizeof(msgData), 0);
	if(retval == SOCKET_ERROR)
	{
		err_display("send()");
		exit(1);
	}
	retval = recv(sock, (char *)&msgAck, sizeof(msgAck), 0);
	if(retval == SOCKET_ERROR)
	{
		err_display("send()");
		exit(1);
	}
	currbytes = msgData.offset = msgAck.offset;		// offset  ġ Ǿ.
	if(totalsize == currbytes)
	{
		printf("̹     ö ֽϴ.\n\n");
		exit(1);
	}
	//   
	fseek(fp, currbytes, SEEK_SET); //  ͸   ġ ̵
	if(currbytes)
		file_resend = true;
	numtotal += currbytes;			// .. ̰ ࿩ ̾ޱ ۼƮ  

	struct _timeb start, finish;		//  ҿ ð ϱ  
	_ftime(&start);						//   ð 

	/////////////////////////////   ø κ /////////////////////////////
	while(1)
	{
		numread = fread(msgData.buf, 1, BUFSIZE, fp);
		if(numread > 0)
		{
			msgData.datasize = numread;
			
			//    ִ 20ȸ  õѴ.
			int i=0;
			for(; i<20; i++)
			{ 
				//  
				retval = send(sock, (char *)&msgData, sizeof(msgData), 0);
				if(retval == SOCKET_ERROR)
				{
					err_display("send()");
					break;
				}
				
				// ACK ޱ
				retval = recv(sock, (char *)&msgAck, sizeof(msgAck), 0);
				if(retval == SOCKET_ERROR)
				{
					if(WSAGetLastError() == WSAETIMEDOUT)
					{
						err_display("recv()");
						continue;
					}
					else
					{
						err_quit("recv()");
					}
				}

				// ACK ˻
				if(!strncmp(msgAck.filename, msgData.filename, sizeof(msgData.filename))
					&& (msgAck.totalsize == msgData.totalsize)
					&& (msgAck.offset == msgAck.offset))
				{
				//	printf("-> Ack : Offset = %d\n", msgAck.offset);
					numtotal += numread;		
					break;
				}
				else
				{
					printf("[] ߸ Ack ޾ҽϴ.\n");
					fseek(fp, msgAck.offset, SEEK_SET); //  ͸ ߸ ۽ŵ ġ ̵ؼ ٽ 
				}
			} // end of for-loop
			if(i < 20)
				msgData.offset += numread;
			else
			{
				printf("[]  մϴ.\n");
				break;
			}
		}
		else if(numread == 0 && msgData.offset == totalsize)
		{
			printf("->   Ϸ: %d Ʈ\n", totalsize);
			_ftime(&finish);														 //  Ϸ ð 
			//  ҿ ð  & ȭ 
			double elapsed_time = (finish.time * 1000 + finish.millitm)	- (start.time * 1000 + start.millitm);
			printf(" ҿ ð: %.2f seconds.\n", elapsed_time/1000);
			break;
		}
		else
		{
			printf("[]  մϴ.\n");
			break;
		}
		// ۷ Ѵ.
		// ÷ξ å.. Ʈڰ Ŀϱ  KByte 
		//  2^10 = 1024   
		transfer_rate_new = (int)(100 * (numtotal>>10) / (totalsize>>10));	
		if(transfer_rate_new > transfer_rate_old)
		{
			//  KbѴ   2,4,8% ߰ ڰ Ǿ
			//   while Ἥ Ų۴.  ̾ޱ 1% ǹǷ ణ Ѵ.
			while((transfer_rate_new - transfer_rate_old) != 1 && !file_resend)
			{
				printf("۷ = %3d%%\n", ++transfer_rate_old);
			}
			printf("-> Ack : Offset = %d : ", msgAck.offset);
			printf("۷ = %3d%%\n", transfer_rate_new);
		}
		transfer_rate_old = transfer_rate_new;

		
	}
	fclose(fp);

	// closesocket()
	closesocket(sock);

	//  
	WSACleanup();
	return 0;
}